%global     snapdate            20140404
%global     tango_revision      d170ee4
%global     debug_package       %{nil}
%global     alphatag            %{snapdate}git%{tango_revision}

# The source for this package was pulled from upstream's git.
# Use the following commands to generate the tarball:
# git clone git://github.com/SiegeLord/Tango-D2.git tango
# cd tango; git rev-parse --short HEAD            -> for tango_rev
# git checkout %%tango_rev
# git archive --prefix=tango-%%{alphatag}/ HEAD --format=tar | xz > ../tango-%%{alphatag}.tar.xz

Name:           tango
Version:        2
Release:        18%{?dist}
Summary:        The Developer's Library for D

Group:          Development/Libraries
# Preferred license is the Academic Free License v3.0. All Tango project
# release their code under the terms of this license.
# Depending on your needs, the binary attribution of the BSD license may be an
# unwelcome restriction, in which case the AFL is the correct license to apply.
License:        AFL or BSD
URL:            http://www.dsource.org/projects/tango
Source0:        %{name}-%{alphatag}.tar.xz

# https://github.com/ldc-developers/ldc/issues/116
ExcludeArch:    %{arm}


BuildRequires:  ldc, ldc-phobos-devel, ldc-druntime-devel
BuildRequires:  gcc, make

%description
Tango is a cohesive and comprehensive library for the D programming language,
including a complete D runtime along with a tiered set of application services
and utilities.
Tango tries hard to provide a platform agnostic API where it makes sense, and
avoid too many application specific features.
Tango is a cross-platform open-source software library, written in the D
programming language for D programmers.
Availability of solid and extensive documentation represents a prime factor in
library accessibility, and thus this project is as much about documentation
production as it is about top-notch functionality.

%description -l fr
Tango est un projet cohésif et complet pour le langage de programmation
D, incluant un runtime complet du D avec un panel d'application, de services et
d'outils.
Tango s'efforce de fournir une interface de programmation applicative agnostique
où elle prend du sens et d'éviter les trop nombreuses fonctions d'application
spécifiques. Tango est une bibliothèque multi-plateforme libre, écrite en
langage D pour les programmeur du langage D.
Il existe une documentation solide est grandissante de la bibliothèque ce qui
représente un facteur important pour utiliser cette bibliothèque, et ce projet
a une documentation de bonne qualité autant que les fonctionnalité, haut de
gamme qu'elle propose.

%package devel
Summary:        Development files for %{name}
Group:          Development/Libraries

Requires:       %{name}%{?_isa} =  %{version}-%{release}

%description devel
Tango is a cross-platform open-source software library, written in the D
programming language for D programmers. It is structured as a cohesive and
comprehensive library for general purpose usage, and is supported by a growing
number of recognized D enthusiasts.
This package contains static libraries and header files that applications can
use to build against tango.
Include *.d file from tango project for import to your project (it is same
thing as header file *.h in C/C++).
Availability of solid and extensive documentation represents a prime factor in
library accessibility, and thus this project is as much about documentation
production as it is about top-notch functionality.

%description -l fr devel
Tango est une bibliothèque multi-plateforme libre, écrite en language D pour les
programmeur du langage D.  C'est un projet structuré comme une bibliothèque
cohésive et compréhensible pour un usage uiversel, et est soutenu par un nombre
de plus en plus important de fervant developpeur D.
Ce paquet contient aussi la bibliothèque staique et les fichier d'en tête
pour que les applications puissent être developpé avec tango.
Inclut les fichiers *.d du projet tango pour les utiliser dans les import de
votre projets ( c'est la même chose que les en-tête *.h en C/C++ ).
Il existe une documentation solide est grandissante de la bibliothèque ce qui
représente un facteur important pour utiliser cette bibliothèque, et ce projet
a une documentation de bonne qualité autant que les fonctionnalité, haut de
gamme qu'elle propose.

%package doc
Summary:        Documentation and examples for %{name}
Group:          Documentation
Requires:       %{name}-devel = %{version}-%{release}
BuildArch:      noarch

%description doc
Tango html documentation is in /usr/share/doc/tango.
This package contains D file in examples on the usage of tango library and
programming in D. All these files are in /usr/share/tango/examples/ directory.
Examples in:
- concurrency
- conduits (stream)
- console (stdout stderr)
- logging
- networking
- synchronization
- system
- text and xml
- virtual file system

%description -l fr doc
La documentation html pour tango est dans /usr/share/doc/tango.
Contient des fichiers D, montre comment utilisé la bibliothèque tango et la
programmation en D. Tous ces fichiers sont dans le dossier
/usr/share/tango/examples/.
Exemple en:
- programmation concurrente
- flux
- console (stdout stderr)
- génération de log
- réseau
- synchronisation
- système
- teste et xml
- système virtuel de fichier

%package geany-tags
Summary:        Support for enable autocompletion in geany
Group:          Development/Tools
Requires:       %{name} =  %{version}-%{release}
Requires:       geany
BuildRequires:  geany
BuildArch:      noarch

%description geany-tags
Enable autocompletion for tango library in geany (IDE)

%description -l fr geany-tags
Active l'autocompletion pour pour la bibliothèque tango dans geany (IDE)

%prep
%setup -q -n %{name}-%{alphatag}
# remove binaries
rm -rf ./build/bin/*
# fix end of line
find . -type f \( -name "*.d" -or -name "*.xml" \) -exec sed -i 's/\r//' {} \;
# temp geany config directory for allow geany to generate tags
mkdir geany_config
%build
#./build/script/bob.rb -v -r ldc -c ldc  -p linux .
make %{?_smp_mflags} -f build/Makefile DCFLAGS+="%{_d_optflags}" LIBDIR=%{_libdir} DCFLAGS_IMPORT="-Itango" all-shared

# generate geany tags
geany -c geany_config -g tango.d.tags $(find tango/ -name "*.d")

%install
mkdir -p %{buildroot}%{_libdir}/
mkdir -p %{buildroot}%{_datadir}/pkgconfig
mkdir -p %{buildroot}%{_d_includedir}/%{name}
mkdir -p %{buildroot}/%{_datadir}/geany/tags/

# Tango
make %{?_smp_mflags} -f build/Makefile DCFLAGS+="%{_d_optflags} -d" DESTDIR=%{buildroot} DATA_DIR=%{_datadir} INCLUDE_DIR=%{_d_includedir} LIB_DIR=%{_libdir} install-shared
pushd %{buildroot}%{_libdir}/
ln -s libtango-ldc.so.2 libtango-ldc.so.2.0.0
ln -s libtango-ldc.so.2 libtango-ldc.so
popd

# Geany tag
install -m0755 tango.d.tags %{buildroot}/%{_datadir}/geany/tags/

%files
%{_libdir}/lib%{name}-ldc.so.2
%{_libdir}/lib%{name}-ldc.so.2.0.0

%files devel
%{_libdir}/lib%{name}-ldc.so
%{_d_includedir}/%{name}
%{_datadir}/pkgconfig/%{name}.pc

%files doc
%doc doc/example README.md LICENSE.txt
%{_docdir}/%{name}/


%files geany-tags
%{_datadir}/geany/tags/%{name}.d.tags


%changelog
* Tue May 20 2014 jonathan MERCIER <bioinfornatics@gmail.com> - 2-18
- update to latest rev

* Sun Mar 09 2014 jonathan MERCIER <bioinfornatics@gmail.com> - 2-17
- Update to latest rev

* Wed Oct 30 2013 Jonathan MERCIER <bioinfornatics@gmail.com> - 2-16
- exclude arm

* Thu Oct 24 2013 Jonathan MERCIER <bioinfornatics@gmail.com> - 2-15
- Update to rev ff2b1d3

* Sun Aug 04 2013 "Jonathan Mercier" <"Jonathan Mercier at gmail dot org"> - 2-14
- Update to rev 667c566

* Mon Jun 10 2013 Jonathan MERCIER <bioinfornatics at fedoraproject dot org> - 2-13
- Update to rev 96fea24

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2-12.20120821git7b92443
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Oct 03 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-11.20120821git7b92443
- update

* Sun Aug 12 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-10.20120731gitb4c308f5
- Update to nex rev

* Thu Jun 14 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-9.20120421gitb3f47b9
- rebuild dmdfe 2.059

* Thu Jun 14 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-8.20120421gitb3f47b9
- rebuild dmdfe 2.059

* Sun Jun 10 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-7.20120421gitb3f47b9
- rebuilt

* Wed Jun 06 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-6.20120421gitb3f47b9
- fix spec file

* Fri May 25 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-5.2012021gitb3f47b9
- update to latest tango rev, with dmdfe 2.059

* Thu Feb 16 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-4.20120206gitc6be365
- update to latest tango rev who fix build with dmdfe 2.058

* Thu Feb 16 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-3.20120206gitc6be365
- Rebuild against latest ldc release

* Mon Feb 06 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-2.20120206gitfcb803f
- update to latest git rev c6be365

* Sat Jan 7 2012 Jonathan MERCIER <bioinfornatics at gmail.com>  2-1.20111231git7048209
- Update Tango to new major release D2 support

* Wed Oct 13 2010  Jonathan MERCIER <bioinfornatics at gmail.com>  0.99.9-21.20101012svn5569
- Update to revision 5569

* Tue Sep 28 2010 Jonathan MERCIER <bioinfornatics at gmail.com>  0.99.9-20.20100928svn5567
- Update to revision 5567

* Thu Aug 26 2010 Jonathan MERCIER <bioinfornatics at gmail.com>  0.99.9-19.20100919svn5561
- Update to revision 5561

* Thu Aug 26 2010 Jonathan MERCIER <bioinfornatics at gmail.com>  0.99.9-19.20100826svn5543
- Update to revision 5543

* Sun Aug 22 2010 Jonathan MERCIER <bioinfornatics at gmail.com>  0.99.9-18.20100818svn5529
- Update to revision 5529

* Wed Aug 11 2010 Jonathan MERCIER <bioinfornatics at gmail.com>  0.99.9-17.20100818svn5525
- Update to revision 5525

* Wed Aug 11 2010 Jonathan MERCIER <bioinfornatics at gmail.com>  0.99.9-15.20100809svn5519
- Update to revision 5519

* Tue Aug 03 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-15.20100802svn5517
- Update to revision 5517

* Tue Aug 03 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-14.20100802svn5515
- Add BuildArch noarch for -doc sub package

* Tue Aug 03 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-13.20100802svn5515
- Perform spec file

* Tue Aug 03 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-12.20100802svn5515
- merge doc and example

* Tue Aug 03 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-11.20100802svn5515
- replace rm -rf %%{name}/core/rt/compiler with rm -rf %%{name}/core/rt
- add package for doc and example

* Mon Aug 02 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-10.20100802svn5515
- Update to revivion 5515

* Thu Jul 29 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-9.20100729svn5508
- Use %%{_d_libdir} instead %%{_libdir}
- Use %%{_d_optflags} instead -release

* Mon Jul 26 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-8.20100726svn5508
- Update to revivion 5508

* Tue Jul 20 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-7.20100720svn5505
- remove tango/core/rt directory in %%install section
- put object.di in %%{_d_includedir}

* Tue Jul 20 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-6.20100720svn5505
- Put documentation and example in devel package
- Change alphatag to YYYYMMDD instead YYYYDDMM
- Update to revivion 5505

* Mon Jul 12 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-5.20101207svn5498
- Update to revivion 5498

* Tue Jul 06 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-4.20100706svn5487
- Fix ruby script

* Thu Jul 01 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-3.2010701svn5487
- Perform french description

* Wed Jun 30 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-2.20100630svn5487
- Fix typo, subversion instead mercurial
- Perform summary and description package
- use ruby script instead binary

* Wed Jun 23 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 0.99.9-1.20102406svn5487
- Initial release
